"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepComparison = exports.entriesEqual = exports.couple = exports.getList = exports.getId = exports.extractDirectedRelation = void 0;
var extractDirectedRelation = function (config, direction) {
    var split = {
        here: config["vertex".concat(direction == 'A->B' ? 'A' : 'B')].anchor.split('.'),
        there: config["vertex".concat(direction == 'A->B' ? 'B' : 'A')].anchor.split('.')
    };
    return {
        here: {
            collection: split.here[0],
            list: split.here[1],
            field: split.here[2]
        },
        there: {
            collection: split.there[0],
            list: split.there[1],
            field: split.there[2]
        }
    };
};
exports.extractDirectedRelation = extractDirectedRelation;
var getId = function (entry) {
    return typeof entry == 'string' ? entry : entry ? entry.id : undefined;
};
exports.getId = getId;
var getList = function (config, direction, data) {
    return data[(0, exports.extractDirectedRelation)(config, direction).here.list];
};
exports.getList = getList;
var getRelationMeta = function (entry, field) {
    var _a = entry, _b = field, relationObject = _a[_b], id = _a.id, relationMeta = __rest(_a, [typeof _b === "symbol" ? _b : _b + "", "id"]);
    return relationMeta;
};
var couple = function (docHere, relationEntries, config, direction, req, mode, context) { return __awaiter(void 0, void 0, void 0, function () {
    var _a, here, there, docHereId, _i, relationEntries_1, entryHere, docThereId, relationMetaHere, newEntryThere, entriesThere, matches, updateNeeded, e_1;
    var _b, _c;
    return __generator(this, function (_d) {
        switch (_d.label) {
            case 0:
                _a = (0, exports.extractDirectedRelation)(config, direction), here = _a.here, there = _a.there;
                docHereId = (0, exports.getId)(docHere);
                if (!docHereId) return [3 /*break*/, 9];
                _i = 0, relationEntries_1 = relationEntries;
                _d.label = 1;
            case 1:
                if (!(_i < relationEntries_1.length)) return [3 /*break*/, 9];
                entryHere = relationEntries_1[_i];
                docThereId = (0, exports.getId)(entryHere[here.field]);
                if (!docThereId) return [3 /*break*/, 8];
                relationMetaHere = getRelationMeta(entryHere, here.field);
                newEntryThere = __assign((_b = {}, _b[there.field] = docHereId, _b), relationMetaHere);
                _d.label = 2;
            case 2:
                _d.trys.push([2, 6, 7, 8]);
                return [4 /*yield*/, req.payload.findByID({
                        collection: there.collection,
                        id: docThereId,
                        depth: 2
                    })];
            case 3:
                entriesThere = (_d.sent())[there.list];
                matches = entriesThere.filter(function (entryThere) { return (0, exports.getId)(entryThere[there.field]) == docHereId; });
                updateNeeded = mode == 'decoupling' ? matches.length > 0 : (matches.length != 1 ? true : !(0, exports.deepComparison)(relationMetaHere, getRelationMeta(matches[0], there.field)));
                if (!updateNeeded) return [3 /*break*/, 5];
                return [4 /*yield*/, req.payload.update({
                        collection: there.collection,
                        id: docThereId,
                        data: (_c = {},
                            _c[there.list] = __spreadArray(__spreadArray([], entriesThere.filter(function (entry) { return (0, exports.getId)(entry[there.field]) != docHereId; }).map(function (entry) {
                                entry[there.field] = (0, exports.getId)(entry[there.field]);
                                return entry;
                            }), true), (mode == 'decoupling' ? [] : [newEntryThere]), true),
                            _c),
                        context: __assign(__assign({}, context), { updateCameFrom: docHereId })
                    })];
            case 4:
                _d.sent();
                _d.label = 5;
            case 5: return [3 /*break*/, 8];
            case 6:
                e_1 = _d.sent();
                console.log(e_1);
                return [3 /*break*/, 8];
            case 7:
                console.log("".concat(mode, " of ").concat(here.collection, ".").concat(docHereId, " and ").concat(there.collection, ".").concat(docThereId));
                return [7 /*endfinally*/];
            case 8:
                _i++;
                return [3 /*break*/, 1];
            case 9: return [2 /*return*/];
        }
    });
}); };
exports.couple = couple;
var entriesEqual = function (entry1, entry2, field) {
    var _a = entry1, _b = field, relationObject1 = _a[_b], _ = _a.id, relationMeta1 = __rest(_a, [typeof _b === "symbol" ? _b : _b + "", "id"]);
    var _c = entry2, _d = field, relationObject2 = _c[_d], __ = _c.id, relationMeta2 = __rest(_c, [typeof _d === "symbol" ? _d : _d + "", "id"]);
    return (0, exports.getId)(relationObject1) == (0, exports.getId)(relationObject2) && (0, exports.deepComparison)(relationMeta1, relationMeta2);
};
exports.entriesEqual = entriesEqual;
var deepComparison = function (object1, object2) {
    var keys1 = Object.keys(object1);
    var keys2 = Object.keys(object2);
    if (keys1.length !== keys2.length)
        return false;
    if (keys1.filter(function (key) { return !keys2.includes(key); }).length > 0)
        return false;
    for (var _i = 0, keys1_1 = keys1; _i < keys1_1.length; _i++) {
        var key = keys1_1[_i];
        var val1 = object1[key];
        var val2 = object2[key];
        var deepen = val1 != null && typeof val1 === 'object' && val2 != null && typeof val2 === 'object';
        if (deepen && !(0, exports.deepComparison)(val1, val2) || !deepen && val1 !== val2)
            return false;
    }
    return true;
};
exports.deepComparison = deepComparison;
//# sourceMappingURL=helpers.js.map