"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.biDirectionalRelationships = exports.biDirectionalRelationship = void 0;
var field_1 = require("./field");
var helpers_1 = require("./helpers");
var hooks_1 = require("./hooks");
var biDirectionalRelationship = function (config) {
    var _a, _b;
    var _c = (0, helpers_1.extractDirectedRelation)(config, 'A->B'), here = _c.here, there = _c.there;
    return {
        config: config,
        anchors: (_a = {},
            _a[here.collection] = (0, field_1.relationList)(config, 'A->B'),
            _a[there.collection] = (0, field_1.relationList)(config, 'B->A'),
            _a),
        hooks: (_b = {},
            _b[here.collection] = (0, hooks_1.afterDocumentDelete)(config, 'A->B'),
            _b[there.collection] = (0, hooks_1.afterDocumentDelete)(config, 'B->A'),
            _b)
    };
};
exports.biDirectionalRelationship = biDirectionalRelationship;
var biDirectionalRelationships = function (relationships) {
    return function (incomingConfig) {
        var _a, _b, _c, _d, _e, _f;
        return (__assign(__assign({}, incomingConfig), { collections: (incomingConfig.collections || []).map(function (collection) {
                var _a, _b;
                return (__assign(__assign({}, collection), { hooks: __assign(__assign({}, collection.hooks), { afterDelete: __spreadArray(__spreadArray([], (_b = (_a = collection.hooks) === null || _a === void 0 ? void 0 : _a.afterDelete) !== null && _b !== void 0 ? _b : [], true), relationships
                            .filter(function (relationship) { return Object.keys(relationship.hooks).includes(collection.slug); })
                            .map(function (relationship) { return relationship.hooks[collection.slug]; }), true) }) }));
            }), i18n: {
                resources: {
                    de: __assign(__assign({}, (_c = (_b = (_a = incomingConfig.i18n) === null || _a === void 0 ? void 0 : _a.resources) === null || _b === void 0 ? void 0 : _b.de) !== null && _c !== void 0 ? _c : {}), { biDirectionalRelationships: {
                            validationError: 'Es gibt bereits eine Beziehung zu diesem Element. Duplikate sind nicht erlaubt.'
                        } }),
                    en: __assign(__assign({}, (_f = (_e = (_d = incomingConfig.i18n) === null || _d === void 0 ? void 0 : _d.resources) === null || _e === void 0 ? void 0 : _e.en) !== null && _f !== void 0 ? _f : {}), { biDirectionalRelationships: {
                            validationError: 'There is already a relation to this element. Duplicates are not allowed.'
                        } })
                }
            } }));
    };
};
exports.biDirectionalRelationships = biDirectionalRelationships;
//# sourceMappingURL=index.js.map